/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.interfaces;


import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import java.io.Serializable;

import javax.annotation.Generated;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public interface ISensor extends VertxPojo, Serializable {

    /**
     * Setter for <code>public.sensor.senid</code>.
     */
    public ISensor setSenid(Integer value);

    /**
     * Getter for <code>public.sensor.senid</code>.
     */
    public Integer getSenid();

    /**
     * Setter for <code>public.sensor.sendescricao</code>.
     */
    public ISensor setSendescricao(String value);

    /**
     * Getter for <code>public.sensor.sendescricao</code>.
     */
    public String getSendescricao();

    /**
     * Setter for <code>public.sensor.senparametro</code>.
     */
    public ISensor setSenparametro(String value);

    /**
     * Getter for <code>public.sensor.senparametro</code>.
     */
    public String getSenparametro();

    /**
     * Setter for <code>public.sensor.senatualizacao</code>.
     */
    public ISensor setSenatualizacao(Integer value);

    /**
     * Getter for <code>public.sensor.senatualizacao</code>.
     */
    public Integer getSenatualizacao();

    /**
     * Setter for <code>public.sensor.senativo</code>.
     */
    public ISensor setSenativo(String value);

    /**
     * Getter for <code>public.sensor.senativo</code>.
     */
    public String getSenativo();

    /**
     * Setter for <code>public.sensor.senvirtual</code>.
     */
    public ISensor setSenvirtual(String value);

    /**
     * Getter for <code>public.sensor.senvirtual</code>.
     */
    public String getSenvirtual();

    /**
     * Setter for <code>public.sensor.fktipsenid</code>.
     */
    public ISensor setFktipsenid(Integer value);

    /**
     * Getter for <code>public.sensor.fktipsenid</code>.
     */
    public Integer getFktipsenid();

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * Load data from another generated Record/POJO implementing the common interface ISensor
     */
    public void from(com.tabajara.base.tables.interfaces.ISensor from);

    /**
     * Copy data into another generated Record/POJO implementing the common interface ISensor
     */
    public <E extends com.tabajara.base.tables.interfaces.ISensor> E into(E into);

    @Override
    public default ISensor fromJson(io.vertx.core.json.JsonObject json) {
        setSenid(json.getInteger("senid"));
        setSendescricao(json.getString("sendescricao"));
        setSenparametro(json.getString("senparametro"));
        setSenatualizacao(json.getInteger("senatualizacao"));
        setSenativo(json.getString("senativo"));
        setSenvirtual(json.getString("senvirtual"));
        setFktipsenid(json.getInteger("fktipsenid"));
        return this;
    }


    @Override
    public default io.vertx.core.json.JsonObject toJson() {
        io.vertx.core.json.JsonObject json = new io.vertx.core.json.JsonObject();
        json.put("senid",getSenid());
        json.put("sendescricao",getSendescricao());
        json.put("senparametro",getSenparametro());
        json.put("senatualizacao",getSenatualizacao());
        json.put("senativo",getSenativo());
        json.put("senvirtual",getSenvirtual());
        json.put("fktipsenid",getFktipsenid());
        return json;
    }

}
